
'nomainwin

UpperLeftX   = 50
UpperLeftY   = 50
WindowWidth  =880
WindowHeight =630

graphicbox #w.gb1,  20, 20, 640, 540
statictext #w.st, "",680, 20, 180, 460

L =400

open "Bifilar coordinates used to create a giant pen-plotter." for window as #w

#w "trapclose [quit]"

#w.st "Suspension threads are wound in/out from the two centres to position the working 'head' at the position desired."_
+chr$( 13) +chr$( 13) +"The head can be a felt-tip pen, router, LED (for time exposures) or whatever you wish."_
+chr$( 13) +chr$( 13) +"Location can be specified as a function of x/y; as a function of l1/l2; or from an SVG file path description."_
+chr$( 13) +chr$( 13) +"The commands are sent via an EiBotBoard controller to two stepper motors with winding drums mounted axially. "_
+chr$( 13) +chr$( 13) +"Commands like 'sm, 1000, 500, 456' tell the two motors to step 500 and 456 steps resp'y in the next 1 second."_
+chr$( 13) +chr$( 13) +"Have a look at the results Chris has got at http://www.fastness.co.uk/"_
+chr$( 13) +chr$( 13) +"In the screengrab he's using a raster scan of a photo, and getting grey scale as a modulated wave..."_
+chr$( 13) +chr$( 13) +"  P.S. The threads are NOT drawn in the simulation. Easily added if you want, tho'."

loadbmp "scr", "bifilar.bmp"
#w.gb1 "down ; fill darkblue ; drawbmp scr 12 50 ; flush"

timer 4000, [start]
wait
[start]
timer 0

#w.gb1, "fill white ; backcolor black"

#w.gb1 "up ; goto "; 100; " "; 100
#w.gb1 "down ; circlefilled 10"
#w.gb1 "up"

#w.gb1 "goto "; 500; " "; 100
#w.gb1 "down ; circlefilled 10 "
#w.gb1 "up ; flush ; color red"

#w.gb1 "rule "; _R2_XORPEN

open "liberty.svg" for input as #i
content$  =input$( #i, lof( #i))
close #i
s         =instr( content$, "d=" +chr$( 34) +"m ")
content$  =mid$( content$, s +5, len( content$))

flag$     =""
c         =1

do
    [here]
    xypair$ =word$( content$, c, " ")
    if xypair$ ="z" and word$( content$, c +1, " ") ="m" then c =c +2: goto [here]
    if xypair$ ="" then wait
    x       =int( 0.5 +val( word$( xypair$, 1, ","))) : x =x +200
    y       =int( 0.5 +val( word$( xypair$, 2, ","))) : y =y +200
    c       =c +1
    print c, xypair$, tab( 50), x, y

    #w.gb1 "color red ; size 1"
    #w.gb1 "rule "; _R2_NOTXORPEN

    #w.gb1 "goto "; 100; " "; 100
    #w.gb1 "down ; circle "; y /cos( atan2( x, y))
    #w.gb1 "up"

    timer 50, [tick1c]
    wait
    [tick1c]
    timer 0

    #w.gb1 "goto "; 100; " "; 100
    #w.gb1 "down ; circle "; y /cos( atan2( x, y))
    #w.gb1 "up"


    #w.gb1 "color green"

    #w.gb1 "goto "; 500; " "; 100
    #w.gb1 "down ; circle "; y /cos( atan2( ( L -x), y))
    #w.gb1 "up"

    timer 50, [tick2c]
    wait
    [tick2c]
    timer 0

    #w.gb1 "goto "; 500; " "; 100
    #w.gb1 "down ; circle "; y /cos( atan2( ( L -x), y))
    #w.gb1 "up"

    #w.gb1 "color darkblue ; size 2"
    #w.gb1 "rule "; _R2_COPYPEN
    #w.gb1 "goto "; 100 +x; " "; 100 +y
    #w.gb1 "down ; set "; 100 +x; " "; 100 +y
    #w.gb1 "up"

loop until ( c >100) or ( flag$ ="end")

wait

for theta =0 to 30 step 0.1
    x =200 +200 *sin( theta) *exp( ( 0 -theta) /50)
    y =200 +140 *cos( theta) *exp( ( 0 -theta) /50)

    #w.gb1 "color red ; size 1"
    #w.gb1 "rule "; _R2_NOTXORPEN

    #w.gb1 "goto "; 100; " "; 100
    #w.gb1 "down ; circle "; y /cos( atan2( x, y))
    #w.gb1 "up"

    timer 50, [tick1a]
    wait
    [tick1a]
    timer 0

    #w.gb1 "goto "; 100; " "; 100
    #w.gb1 "down ; circle "; y /cos( atan2( x, y))
    #w.gb1 "up"


    #w.gb1 "color green"

    #w.gb1 "goto "; 500; " "; 100
    #w.gb1 "down ; circle "; y /cos( atan2( ( L -x), y))
    #w.gb1 "up"

    timer 50, [tick2a]
    wait
    [tick2a]
    timer 0

    #w.gb1 "goto "; 500; " "; 100
    #w.gb1 "down ; circle "; y /cos( atan2( ( L -x), y))
    #w.gb1 "up"

    #w.gb1 "color darkblue ; size 2"
    #w.gb1 "rule "; _R2_COPYPEN
    #w.gb1 "goto "; 100 +x; " "; 100 +y
    #w.gb1 "down ; set "; 100 +x; " "; 100 +y
    #w.gb1 "up"

next theta

for x =0 to 400
    y =200 +100 *sin( x /10) *exp( ( 0 -x) /100)

    #w.gb1 "color red ; size 1"
    #w.gb1 "rule "; _R2_NOTXORPEN

    #w.gb1 "goto "; 100; " "; 100
    #w.gb1 "down ; circle "; y /cos( atan2( x, y))
    #w.gb1 "up"

    timer 50, [tick1]
    wait
    [tick1]
    timer 0

    #w.gb1 "goto "; 100; " "; 100
    #w.gb1 "down ; circle "; y /cos( atan2( x, y))
    #w.gb1 "up"


    #w.gb1 "color green"

    #w.gb1 "goto "; 500; " "; 100
    #w.gb1 "down ; circle "; y /cos( atan2( ( L -x), y))
    #w.gb1 "up"

    timer 50, [tick2]
    wait
    [tick2]
    timer 0

    #w.gb1 "goto "; 500; " "; 100
    #w.gb1 "down ; circle "; y /cos( atan2( ( L -x), y))
    #w.gb1 "up"

    #w.gb1 "color darkblue ; size 2"
    #w.gb1 "rule "; _R2_COPYPEN
    #w.gb1 "goto "; 100 +x; " "; 100 +y
    #w.gb1 "down ; set "; 100 +x; " "; 100 +y
    #w.gb1 "up"

next x

wait

[quit]
close #w
end

function atan2( y, x)
    pi      = atn( 1) *4
    Result$ = "Undetermined"
    if ( x =0) and ( y >0) then atan2 = pi /2:      Result$ ="Determined"
    if ( x =0) and ( y <0) then atan2 =3 * pi /2:   Result$ ="Determined"
    if ( x >0) and ( y =0) then atan2 =0:           Result$ ="Determined"
    if ( x <0) and ( y =0) then atan2 =pi:          Result$ ="Determined"

    if Result$ <>"Determined" then
        BaseAngle =atn( abs( y) /abs( x))
        if ( x >0) and ( y >0) then atan2 =       BaseAngle
        if ( x <0) and ( y >0) then atan2 = pi   -BaseAngle
        if ( x <0) and ( y <0) then atan2 = pi   +BaseAngle
        if ( x >0) and ( y <0) then atan2 = 2*pi -BaseAngle
    end if
end function


